<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 Nathan Lenz <nathan.lenz@organicvalley.coop>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(t3lib_extMgm::extPath('rtehtmlarea').'pi2/class.tx_rtehtmlarea_pi2.php');

/**
 * Plugin 'Demo 14896 Bug Form' for the 'bug14896' extension.
 *
 * @author	Nathan Lenz <nathan.lenz@organicvalley.coop>
 * @package	TYPO3
 * @subpackage	tx_bug14896
 */
class tx_bug14896_pi1 extends tslib_pibase {
	public $prefixId      = 'tx_bug14896_pi1';		// Same as class name
	public $scriptRelPath = 'pi1/class.tx_bug14896_pi1.php';	// Path to this script relative to the extension dir.
	public $extKey        = 'bug14896';	// The extension key.
	
	/**
	 * These are needed for the RTE
	 */
	public $RTEObj;
	public $docLarge = 0;
	public $RTEcounter = 0;
	public $formName;
	    // Initial JavaScript to be printed before the form
	    // (should be in head, but cannot due to IE6 timing bug)
	public $additionalJS_initial = '';
	    // Additional JavaScript to be printed before the form
	    // (works in Mozilla/Firefox when included in head, but not in IE6)
	public $additionalJS_pre = array();
	    // Additional JavaScript to be printed after the form
	public $additionalJS_post = array();
	    // Additional JavaScript to be executed on submit
	public $additionalJS_submit = array();
	public $PA = array(
		'itemFormElName' =>  '',
		'itemFormElValue' => '',
	);
	public $specConf = array(
		'rte_transform' => array(
		'parameters' => array('mode' => 'ts_css')
		)
	);
	public $thisConfig = array();
	public $RTEtypeVal = 'text';
	public $thePidValue;
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	public function main($content, $conf) {
		
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		$this->RTEObj = t3lib_div::makeInstance('tx_rtehtmlarea_pi2');
		
		if($this->RTEObj->isAvailable()) {
		
			$this->RTEcounter++;
			$this->table = 'tt_content';
			$this->field = 'bodytext';
			$this->formName = 'testWYSIWYG';
			$this->PA['itemFormElName'] = $this->prefixId.'[bodytext]';
			$this->PA['itemFormElValue'] = '';
			$this->thePidValue = $GLOBALS['TSFE']->id;
			
			$RTEItem = $this->RTEObj->drawRTE(
				$this,
				'tt_content',
				'bodytext',
				$row=array(),
				$this->PA,
				$this->specConf,
				$this->thisConfig,
				$this->RTEtypeVal,
				'',
				$this->thePidValue);
						
			$preFormJS = $this->additionalJS_initial.'
			<script type="text/javascript">'. implode(chr(10), $this->additionalJS_pre).'
			</script>';
			
			$postJS = '
			<script type="text/javascript">'. implode(chr(10), $this->additionalJS_post).'
			</script>';
			
			$onSubmit = implode(';', $this->additionalJS_submit);
			
		} 
		
		$content='
			<strong>This is a few paragraphs:</strong><br />
			<p>This is line 1</p>
			<p>This is line 2</p>
	
			<h3>This is a form:</h3>
			'.$preFormJS.'
			<form name="testWYSIWYG" action="'.$this->pi_getPageLink($GLOBALS['TSFE']->id).'" method="POST" onsubmit="'.$onSubmit.'">
				<input type="text" name="'.$this->prefixId.'[input_field]" value="'.htmlspecialchars($this->piVars['input_field']).'">';
		
		$content .= $RTEItem;
		
		$content .=	'<input type="submit" name="'.$this->prefixId.'[submit_button]" value="'.htmlspecialchars($this->pi_getLL('submit_button_label')).'">
			</form>
			'.$postJS.'
			<br />
			<p>You can click here to '.$this->pi_linkToPage('get to this page again',$GLOBALS['TSFE']->id).'</p>
		';
	
		return $this->pi_wrapInBaseClass($content);
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/bug14896/pi1/class.tx_bug14896_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/bug14896/pi1/class.tx_bug14896_pi1.php']);
}

?>